/*
// Permission to use, copy, modify, and distribute this software and its
// documentation for any purpose and without fee is hereby granted, provided
// that the above copyright notice appear in all copies and that both that
// copyright notice and this permission notice appear in supporting
// documentation, and that the name of I.B.M. not be used in advertising
// or publicity pertaining to distribution of the software without specific,
// written prior permission. I.B.M. makes no representations about the
// suitability of this software for any purpose.  It is provided "as is"
// without express or implied warranty.
//
// I.B.M. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL I.B.M.
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
// OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
// CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
//
// Author:  Barry Minor, IBM AWS Graphics Systems (Austin)
*/

#define         MAXVERTS        40000
#define         MAXPOLYSIDES    100
#define         PI              3.14159265359
#define         SMALL           9e-99
#define         BIG             9e99
#define         ZMIN            0x0
#define         ZMAX            0x7fffff

#define MAX(a,b)        ((a)>(b)?(a):(b))  /* return greater of a and b */
#define MIN(a,b)        ((a)<(b)?(a):(b))  /* return lesser of a and b */

#define ARG_INC  { argv++; argc--; }

#define FATAL_ERROR(s)                                                        \
{                                                                             \
  fprintf (stderr, s);                                                        \
  fflush (stderr);                                                            \
  exit (-1);                                                                  \
}

#define NOINPUT         0
#define POLYGONINPUT    1
#define MESHINPUT       2

#define POINTmode           0
#define VECTORmode          1
#define LINEmode            2
#define POLYGONmode         3
#define TFANmode            4
#define TMESHmode           5

#define TRUE		1
#define FALSE           0 

#define         XPIX    1280
#define         YPIX    1024
#define         NUMPIX  XPIX*YPIX

struct plygon
{
        int     numverts;
        int     *index;
};

struct vector
{
        float   x;
        float   y;
        float   z;
};

struct colorvector
{
        float   r;
        float   g;
        float   b;
};

struct mesh
{
        int             numverts;
        struct vector   *verts;
        struct vector   *norms;
        struct vector   *texture;
        struct colorvector *vcolor;
};
